org.apache.cxf.bus.extension

## Class ExtensionManagerImpl

- java.lang.Object
- - org.apache.cxf.bus.extension.ExtensionManagerImpl

- All Implemented Interfaces:
    ExtensionManager, ConfiguredBeanLocator

      public class ExtensionManagerImpl
      extends Object
      implements ExtensionManager, ConfiguredBeanLocator

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.cxf.configuration.ConfiguredBeanLocator

      `ConfiguredBeanLocator.BeanLoaderListener<T>`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `ACTIVATION_NAMESPACES_PROPERTY_NAME`
    `static String` | `ACTIVATION_NAMESPACES_SETTER_METHOD_NAME`
    `static String` | `BUS_EXTENSION_RESOURCE`
    `static String` | `EXTENSIONMANAGER_PROPERTY_NAME`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ExtensionManagerImpl(ClassLoader cl, Map<Class<?>,Object> initialExtensions, ResourceManager rm, Bus b)`
    `ExtensionManagerImpl(String[] resources, ClassLoader cl, Map<Class<?>,Object> initialExtensions, ResourceManager rm, Bus b)`
    `ExtensionManagerImpl(String resource, ClassLoader cl, Map<Class<?>,Object> initialExtensions, ResourceManager rm, Bus b)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `activateAll()`
    `<T> void` | `activateAllByType(Class<T> type)`
    `void` | `add(Extension ex)`
    `void` | `destroyBeans()`
    `List<String>` | `getBeanNamesOfType(Class<?> type)` Gets the names of all the configured beans of the specific type.
    `<T> T` | `getBeanOfType(String name, Class<T> type)` Gets the bean of the given name and type
    `<T> Collection<? extends T>` | `getBeansOfType(Class<T> type)` Gets all the configured beans of the specific types.
    `<T> T` | `getExtension(String name, Class<T> type)`
    `boolean` | `hasBeanOfName(String name)`
    `boolean` | `hasConfiguredPropertyValue(String beanName, String propertyName, String value)` For supporting "legacy" config, checks the configured bean to see if it has a property configured with the given name/value.
    `void` | `initialize()`
    `<T> boolean` | `loadBeansOfType(Class<T> type, ConfiguredBeanLocator.BeanLoaderListener<T> listener)` Iterates through the beans of the given type, calling the listener to determine if it should be loaded or not.
    `void` | `removeBeansOfNames(List<String> names)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### EXTENSIONMANAGER_PROPERTY_NAME

          public static final String EXTENSIONMANAGER_PROPERTY_NAME

      See Also:
        Constant Field Values

    - #### ACTIVATION_NAMESPACES_PROPERTY_NAME

          public static final String ACTIVATION_NAMESPACES_PROPERTY_NAME

      See Also:
        Constant Field Values

    - #### ACTIVATION_NAMESPACES_SETTER_METHOD_NAME

          public static final String ACTIVATION_NAMESPACES_SETTER_METHOD_NAME

      See Also:
        Constant Field Values

    - #### BUS_EXTENSION_RESOURCE

          public static final String BUS_EXTENSION_RESOURCE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### ExtensionManagerImpl

          public ExtensionManagerImpl(ClassLoader cl,
                                      Map<Class<?>,Object> initialExtensions,
                                      ResourceManager rm,
                                      Bus b)

    - #### ExtensionManagerImpl

          public ExtensionManagerImpl(String resource,
                                      ClassLoader cl,
                                      Map<Class<?>,Object> initialExtensions,
                                      ResourceManager rm,
                                      Bus b)

    - #### ExtensionManagerImpl

          public ExtensionManagerImpl(String[] resources,
                                      ClassLoader cl,
                                      Map<Class<?>,Object> initialExtensions,
                                      ResourceManager rm,
                                      Bus b)

  - ### Method Detail

    - #### add

          public void add(Extension ex)

    - #### initialize

          public void initialize()

    - #### removeBeansOfNames

          public void removeBeansOfNames(List<String> names)

    - #### activateAll

          public void activateAll()

      Specified by:
        `activateAll` in interface `ExtensionManager`

    - #### activateAllByType

          public <T> void activateAllByType(Class<T> type)

      Specified by:
        `activateAllByType` in interface `ExtensionManager`

    - #### hasBeanOfName

          public boolean hasBeanOfName(String name)

      Specified by:
        `hasBeanOfName` in interface `ConfiguredBeanLocator`

    - #### getExtension

          public <T> T getExtension(String name,
                                    Class<T> type)

      Specified by:
        `getExtension` in interface `ExtensionManager`

    - #### getBeanNamesOfType

          public List<String> getBeanNamesOfType(Class<?> type)

      Description copied from interface: `ConfiguredBeanLocator`
      Gets the names of all the configured beans of the specific type. Does not cause them to be loaded.
      Specified by:
        `getBeanNamesOfType` in interface `ConfiguredBeanLocator`
      Returns:
        List of all the bean names for the given type

    - #### getBeanOfType

          public <T> T getBeanOfType(String name,
                                     Class<T> type)

      Description copied from interface: `ConfiguredBeanLocator`
      Gets the bean of the given name and type
      Specified by:
        `getBeanOfType` in interface `ConfiguredBeanLocator`
      Returns:
        the bean

    - #### getBeansOfType

          public <T> Collection<? extends T> getBeansOfType(Class<T> type)

      Description copied from interface: `ConfiguredBeanLocator`
      Gets all the configured beans of the specific types. Causes them all to be loaded.
      Specified by:
        `getBeansOfType` in interface `ConfiguredBeanLocator`
      Returns:
        The collection of all the configured beans of the given type

    - #### loadBeansOfType

          public <T> boolean loadBeansOfType(Class<T> type,
                                             ConfiguredBeanLocator.BeanLoaderListener<T> listener)

      Description copied from interface: `ConfiguredBeanLocator`
      Iterates through the beans of the given type, calling the listener to determine if it should be loaded or not.
      Specified by:
        `loadBeansOfType` in interface `ConfiguredBeanLocator`
      Returns:
        true if beans of the type were loaded

    - #### hasConfiguredPropertyValue

          public boolean hasConfiguredPropertyValue(String beanName,
                                                    String propertyName,
                                                    String value)

      Description copied from interface: `ConfiguredBeanLocator`
      For supporting "legacy" config, checks the configured bean to see if it has a property configured with the given name/value. Mostly used for supporting things configured with "activationNamespaces" set.
      Specified by:
        `hasConfiguredPropertyValue` in interface `ConfiguredBeanLocator`
      Returns:
        true if the bean has the given property/value

    - #### destroyBeans

          public void destroyBeans()

Apache CXF